import { world, system } from '@minecraft/server'

world.events.beforeChat.subscribe(eventData => {
    let player = eventData.sender
    let player_name = eventData.sender.nameTag
    let message = eventData.message
    let args = eventData.message.split(' ')
    if (message[0] == '>') {
        if (args[0] == '>cinecam') {
            eventData.cancel = true
            if (args[1] == 'launch') {
                let speed = '1'
                let zoom_factor = '0'
                if (args[2] == undefined) {
                    speed = '1'
                }
                else {
                    speed = parseFloat(args[2])
                    if (!(speed >= 0.25 && speed <= 5.00)) {
                        player.runCommandAsync('tellraw @s {"rawtext":[{"text":"§cStrength needs to be more or equal to§a 0.25 §cand less or equal to§a 5§r.§§§aBig number = Slow, more cinematic§r. Default value is §a1."}]}')
                    }
                }
                if (args[3] == '--beta') {
                    if (args[4] == undefined) {
                        player.runCommandAsync('tellraw @s {"rawtext":[{"text":"§cNot enough arguments!"}]}')
                    }
                }
                let loop = system.runInterval(() => {
                    player.runCommandAsync(`camera @s set minecraft:free ease ${speed} linear pos ~~1.7~ rot ~~`)
                    player.runCommandAsync(`effect @s invisibility 1 1 true`)
                    player.runCommandAsync(`effect @s invisibility 1 8 true`)
                    if (args[1] == 'stop') {
                        system.clearInterval(loop)
                    }
                }, 1)
            }
            else if (args[1] == undefined) {
                player.runCommandAsync('tellraw @s {"rawtext":[{"text":"§cNot enough arguments!"}]}')
            }
        }
    }
})